#include "StdAfx.h"
#include ".\nwindowtimer.h"

static const int INVALID_TIMER_ID = -1;
CNWindowTimer::CNWindowTimer(void)
{
	m_dwTimerID = INVALID_TIMER_ID;
}

CNWindowTimer::~CNWindowTimer(void)
{
	_Destroy();
}
BOOL CNWindowTimer::SetTimer(DWORD dwStartDueTime, DWORD dwPeriod, DWORD dwTid, INPTimerHandler* pHandler, ULONG uFlag)
{
	BOOL bSuccess = _Create();
	ATLASSERT(bSuccess);
	if (!bSuccess) return bSuccess;
	Sleep(dwStartDueTime);
	m_dwTimerID = dwTid;
	m_pTimerHandler = pHandler;

	bSuccess = 0 != CWindowImpl<CNWindowTimer>::SetTimer(dwTid, dwPeriod, NULL);

	return bSuccess;
}
BOOL CNWindowTimer::StopTimer()
{
	ATLTRACE(_T("CNWindowTimer::StopTimer\n"));
	if (IsWindow())
	{
		CWindowImpl<CNWindowTimer>::KillTimer(m_dwTimerID);
		m_dwTimerID = INVALID_TIMER_ID;
		//_Destroy();
		return TRUE;
	}
	ATLTRACE(_T("CNWindowTimer::StopTimer - Invalid WindowHandle\n"));
	return FALSE;	
}
BOOL CNWindowTimer::IsRunning()
{
	//return IsWindow();
	return (m_dwTimerID != INVALID_TIMER_ID);
}
BOOL CNWindowTimer::_Create()
{
	BOOL bSuccess = IsWindow();
	if (bSuccess)
	{
		return bSuccess;
	}
	CWindowImpl<CNWindowTimer>::Create(HWND_MESSAGE);
	bSuccess = IsWindow();
	return bSuccess;
}
BOOL CNWindowTimer::_Destroy()
{
	if (IsWindow())
	{
		DestroyWindow();		
	}
	return TRUE;
}
LRESULT CNWindowTimer::OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (wParam == m_dwTimerID)
	{
		ATLASSERT(m_pTimerHandler);
		m_pTimerHandler->OnTimer(m_dwTimerID);
	}
	return 0;
}

void CNWindowTimer::WaitForStop()
{
	MSG msg;
	while (TRUE)
	{
		if (this->IsRunning() == FALSE) break;

		if (::PeekMessage(&msg, NULL, WM_TIMER, WM_TIMER, PM_REMOVE) ||
			::PeekMessage(&msg, NULL, WM_PAINT, WM_PAINT, PM_REMOVE)) 
		{				
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
	}
}